<?php /* SQLインジェクション対策済みのサンプル */

// 検索id取得
$id = $_GET['id'];

// PDOによるMySQL接続 & データ取得
try {
    // PHP 5.3.8以降の設定例。 ATTR_EMULATE_PREPARES をfalse にして静的プレースホルダが働くようにする
    $dbh = new PDO('mysql:host=localhost;dbname=sql_test;charset=utf8', 'dbuser_sql_test', 'dbpass_sql_test', array(PDO::ATTR_EMULATE_PREPARES => false));
    $sql = "select id, name, job, age from users where id = ?"; // 疑問符(?) がプレースホルダで、可変パラメータの場所に埋め込みます。
    $stmt = ($dbh->prepare($sql));
    $stmt->execute(array($id)); // プレースホルダ(?)の設置順に対応させ、パラメータを配列で渡します。
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);
} catch (PDOException $e) {
    var_dump($e->getMessage());
    exit;
}

// 切断
$dbh = null;

// 以下html表示処理
?>
<DOCTYPE!>
<html lang="ja">
<head>
<meta charset="UTF-8">
<title>SQLインジェクションサンプル</title>
</head>
<body>
<h1>問い合わせ結果</h1>
<?php if (empty($result)) : ?>
<p>id:<?php print $id ?> の検索に該当するレコードがありません</p>
<?php else : ?>
<p>id:<?php print $id ?> の検索に該当するレコードが見つかりました</p>
<table>
<thead>
<tr><th>id</th><th>名前</th><th>仕事</th><th>年齢</th></tr>
</thead>
<tbody>
<?php foreach ($result as $value) : ?>
<tr><td><?php print $value['id'] ?></td><td><?php print $value['name'] ?></td><td><?php print $value['job'] ?></td><td><?php print $value['age'] ?></td></tr>
<?php endforeach ?>
</tbody>
</table>
<?php endif ?>
</body>
</html>
